diff --git a/src/modules/Extensions/LastFM.cpp b/src/modules/Extensions/LastFM.cpp
index 99af0d25..e765dd9a 100644
--- a/src/modules/Extensions/LastFM.cpp
+++ b/src/modules/Extensions/LastFM.cpp
@@ -29,9 +29,20 @@ Q_DECLARE_METATYPE(LastFM::Scrobble)
 
 #include <QCryptographicHash>
 #include <QStringList>
-#include <QUrlQuery>
+#include <QUrl>
 #include <QImage>
 
+static QString buildQueryString(const QList<QPair<QString, QString> > &params)
+{
+    QStringList result;
+    for (int i = 0; i < params.size(); ++i)
+    {
+        const QPair<QString, QString> &pair = params.at(i);
+        result << QUrl::toPercentEncoding(pair.first) + "=" + QUrl::toPercentEncoding(pair.second);
+    }
+    return result.join("&");
+}
+
 LastFM::LastFM(Module &module) :
     coverReply(nullptr),
     loginReply(nullptr),
@@ -53,7 +64,10 @@ bool LastFM::set()
     imageSizes.clear();
     if (sets().getBool("LastFM/AllowBigCovers"))
         imageSizes += "mega";
-    imageSizes += {"extralarge", "large", "medium", "small"};
+    imageSizes += "extralarge";
+    imageSizes += "large";
+    imageSizes += "medium";
+    imageSizes += "small";
 
     const QString _user = sets().getString("LastFM/Login");
     const QString _md5pass = sets().getString("LastFM/Password");
@@ -161,19 +175,20 @@ void LastFM::updateNowPlayingAndScrobble(const Scrobble &scrobble)
         QCryptographicHash::Md5
     ).toHex();
 
-    QUrlQuery updateNowPlayingQuery;
-    updateNowPlayingQuery.addQueryItem("method", "track.updatenowplaying");
-    updateNowPlayingQuery.addQueryItem("artist", scrobble.artist);
-    updateNowPlayingQuery.addQueryItem("track", scrobble.title);
-    updateNowPlayingQuery.addQueryItem("album", scrobble.album.isEmpty() ? "" : scrobble.album);
-    updateNowPlayingQuery.addQueryItem("duration", duration);
-    updateNowPlayingQuery.addQueryItem("api_key", api_key);
-    updateNowPlayingQuery.addQueryItem("api_sig", apiSig);
-    updateNowPlayingQuery.addQueryItem("sk", session_key);
+    QList<QPair<QString, QString> > updateNowPlayingParams;
+    updateNowPlayingParams << qMakePair(QString("method"), QString("track.updatenowplaying"));
+    updateNowPlayingParams << qMakePair(QString("artist"), scrobble.artist);
+    updateNowPlayingParams << qMakePair(QString("track"), scrobble.title);
+    updateNowPlayingParams << qMakePair(QString("album"), scrobble.album.isEmpty() ? "" : scrobble.album);
+    updateNowPlayingParams << qMakePair(QString("duration"), duration);
+    updateNowPlayingParams << qMakePair(QString("api_key"), QString(api_key));
+    updateNowPlayingParams << qMakePair(QString("api_sig"), QString(apiSig));
+    updateNowPlayingParams << qMakePair(QString("sk"), session_key);
+
+    QString updateNowPlayingQueryString = buildQueryString(updateNowPlayingParams);
 
-    reply = net.start(audioScrobbler2URL, updateNowPlayingQuery.toString(QUrl::EncodeDelimiters).toUtf8(), NetworkAccess::UrlEncoded);
-    connect(reply, &NetworkReply::finished,
-            reply, &NetworkReply::deleteLater);
+    reply = net.start(audioScrobbler2URL, updateNowPlayingQueryString.toUtf8(), NetworkAccess::UrlEncoded);
+    connect(reply, SIGNAL(finished()), reply, SLOT(deleteLater()));
 
     // scrobble
     const auto ts = QString::number(scrobble.startTime);
@@ -185,25 +200,30 @@ void LastFM::updateNowPlayingAndScrobble(const Scrobble &scrobble)
         QCryptographicHash::Md5
     ).toHex();
 
-    QUrlQuery scrobbleQuery;
-    scrobbleQuery.addQueryItem("method", "track.scrobble");
-    scrobbleQuery.addQueryItem("artist", scrobble.artist);
-    scrobbleQuery.addQueryItem("track", scrobble.title);
-    scrobbleQuery.addQueryItem("timestamp", ts);
-    scrobbleQuery.addQueryItem("album", scrobble.album.isEmpty() ? "" : scrobble.album);
-    scrobbleQuery.addQueryItem("api_key", api_key);
-    scrobbleQuery.addQueryItem("api_sig", apiSig);
-    scrobbleQuery.addQueryItem("sk", session_key);
-
-    reply = net.start(audioScrobbler2URL, scrobbleQuery.toString(QUrl::EncodeDelimiters).toUtf8(), NetworkAccess::UrlEncoded);
+    QList<QPair<QString, QString> > scrobbleParams;
+    scrobbleParams << qMakePair(QString("method"), QString("track.scrobble"));
+    scrobbleParams << qMakePair(QString("artist"), scrobble.artist);
+    scrobbleParams << qMakePair(QString("track"), scrobble.title);
+    scrobbleParams << qMakePair(QString("timestamp"), ts);
+    scrobbleParams << qMakePair(QString("album"), scrobble.album.isEmpty() ? "" : scrobble.album);
+    scrobbleParams << qMakePair(QString("api_key"), QString(api_key));
+    scrobbleParams << qMakePair(QString("api_sig"), QString(apiSig));
+    scrobbleParams << qMakePair(QString("sk"), session_key);
+
+    QString scrobbleQueryString = buildQueryString(scrobbleParams);
+
+    reply = net.start(audioScrobbler2URL, scrobbleQueryString.toUtf8(), NetworkAccess::UrlEncoded);
     reply->setProperty("scrobble", QVariant::fromValue(scrobble));
     m_scrobbleReplies.push_back(reply);
-    connect(reply, &NetworkReply::destroyed,
-            this, [=] {
+    connect(reply, SIGNAL(destroyed(QObject*)), this, SLOT(onReplyDestroyed(QObject*)));
+    connect(reply, SIGNAL(finished()), this, SLOT(scrobbleFinished()));
+}
+
+void LastFM::onReplyDestroyed(QObject* obj)
+{
+    NetworkReply* reply = qobject_cast<NetworkReply*>(obj);
+    if (reply)
         m_scrobbleReplies.removeOne(reply);
-    });
-    connect(reply, &NetworkReply::finished,
-            this, &LastFM::scrobbleFinished);
 }
 
 void LastFM::clear()
@@ -274,7 +294,7 @@ void LastFM::albumFinished()
             emit QMPlay2Core.updateCover(taa[0], taa[1], taa[2], reply);
         else
         {
-            for (const QString &size : asConst(imageSizes))
+            foreach (const QString &size, imageSizes)
             {
                 int idx = reply.indexOf(size);
                 if (idx > -1)
@@ -316,6 +336,7 @@ void LastFM::albumFinished()
     coverReply->deleteLater();
     coverReply = nullptr;
 }
+
 void LastFM::loginFinished()
 {
     if (loginReply->hasError())
@@ -351,6 +372,7 @@ void LastFM::loginFinished()
     loginReply->deleteLater();
     loginReply = nullptr;
 }
+
 void LastFM::scrobbleFinished()
 {
     const auto reply = qobject_cast<NetworkReply *>(sender());
diff --git a/src/modules/Extensions/LastFM.hpp b/src/modules/Extensions/LastFM.hpp
index 3d2b3e73..40b87d48 100644
--- a/src/modules/Extensions/LastFM.hpp
+++ b/src/modules/Extensions/LastFM.hpp
@@ -29,9 +29,10 @@
 
 class QImage;
 
-class LastFM final : public QObject, public QMPlay2Extensions
+class LastFM : public QObject, public QMPlay2Extensions
 {
     Q_OBJECT
+
 public:
     class Scrobble
     {
@@ -48,8 +49,9 @@ public:
     };
 
     LastFM(Module &module);
+
 private:
-    bool set() override;
+    bool set() override final;
 
     void getAlbumCover(const QString &title, const QString &artist, const QString &album, bool titleAsAlbum = false);
 
@@ -59,6 +61,7 @@ private:
     void updateNowPlayingAndScrobble(const Scrobble &scrobble);
 
     void clear();
+
 private slots:
     void updatePlaying(bool play, const QString &title, const QString &artist, const QString &album, int length, bool needCover, const QString &fileName);
 
@@ -67,6 +70,9 @@ private slots:
     void scrobbleFinished();
 
     void processScrobbleQueue();
+
+    void onReplyDestroyed(QObject* obj);
+
 private:
     NetworkReply *coverReply, *loginReply;
     QList<NetworkReply *> m_scrobbleReplies;
diff --git a/src/modules/Extensions/Lyrics.cpp b/src/modules/Extensions/Lyrics.cpp
index 87c1fc18..560d4ea1 100644
--- a/src/modules/Extensions/Lyrics.cpp
+++ b/src/modules/Extensions/Lyrics.cpp
@@ -56,8 +56,10 @@ Lyrics::Lyrics(Module &module) :
 {
     SetModule(module);
 
-    connect(&QMPlay2Core, &QMPlay2CoreClass::updatePlaying,
-            this, &Lyrics::updatePlaying);
+    connect(&QMPlay2Core,
+        SIGNAL(updatePlaying(bool, const QString &, const QString &, const QString &, int, bool, const QString &, const QString &)),
+        this,
+        SLOT(updatePlaying(bool, const QString &, const QString &, const QString &, int, bool, const QString &, const QString &)));
     connect(&m_net, SIGNAL(finished(NetworkReply *)), this, SLOT(finished(NetworkReply *)));
 
     m_dW = new DockWidget;
diff --git a/src/modules/Extensions/Lyrics.hpp b/src/modules/Extensions/Lyrics.hpp
index d4f954a3..572571cc 100644
--- a/src/modules/Extensions/Lyrics.hpp
+++ b/src/modules/Extensions/Lyrics.hpp
@@ -25,15 +25,15 @@
 #include <QTextEdit>
 #include <QPointer>
 
-class Lyrics final : public QTextEdit, public QMPlay2Extensions
+class Lyrics : public QTextEdit, public QMPlay2Extensions
 {
     Q_OBJECT
 
 public:
     Lyrics(Module &module);
-    ~Lyrics();
+    ~Lyrics() final;
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget() override final;
 
 private slots:
     void visibilityChanged(bool v);
diff --git a/src/modules/Extensions/Radio.cpp b/src/modules/Extensions/Radio.cpp
index c0310b5c..92348b29 100644
--- a/src/modules/Extensions/Radio.cpp
+++ b/src/modules/Extensions/Radio.cpp
@@ -24,19 +24,20 @@
 #include <Functions.hpp>
 
 #include <QDesktopServices>
-#include <QJsonDocument>
 #include <QInputDialog>
 #include <QMessageBox>
 #include <QFileDialog>
-#include <QJsonObject>
 #include <QScrollBar>
-#include <QJsonArray>
 #include <QMimeData>
 #include <qevent.h>
 #include <QTimer>
 #include <QMenu>
 #include <QUrl>
 
+#include <QJsonArray.h>
+#include <QJsonDocument.h>
+#include <QJsonObject.h>
+
 constexpr const char *g_fileDialogFilter = "QMPlay2 radio station list (*.qmplay2radio)";
 
 Radio::Radio(Module &module) :
@@ -84,8 +85,8 @@ Radio::Radio(Module &module) :
     ui->radioView->setIconSize({m_radioBrowserModel->elementHeight(), m_radioBrowserModel->elementHeight()});
 
     QHeaderView *header = ui->radioView->header();
-    header->setSectionResizeMode(0, QHeaderView::Stretch);
-    header->setSectionResizeMode(4, QHeaderView::ResizeToContents);
+    header->setResizeMode(0, QHeaderView::Stretch);
+    header->setResizeMode(4, QHeaderView::ResizeToContents);
 
     connect(m_radioBrowserMenu->addAction(tr("Play")), SIGNAL(triggered(bool)), this, SLOT(radioBrowserPlay()));
     connect(m_radioBrowserMenu->addAction(tr("Enqueue")), SIGNAL(triggered(bool)), this, SLOT(radioBrowserEnqueue()));
@@ -109,9 +110,7 @@ Radio::Radio(Module &module) :
     connect(m_net, SIGNAL(finished(NetworkReply *)), this, SLOT(replyFinished(NetworkReply *)));
 
     m_tabChangedOnVisibilityTimer->setSingleShot(true);
-    connect(m_tabChangedOnVisibilityTimer, &QTimer::timeout, this, [=] {
-        tabChanged(currentIndex());
-    });
+    connect(m_tabChangedOnVisibilityTimer, SIGNAL(timeout()), this, SLOT(triggerTabChanged()));
 }
 Radio::~Radio()
 {
@@ -221,6 +220,7 @@ void Radio::searchData()
     ui->radioView->setEnabled(false);
     ui->filterEdit->clear();
 }
+
 void Radio::searchFinished()
 {
     ui->radioView->setEnabled(true);
@@ -285,6 +285,7 @@ void Radio::on_addMyRadioStationButton_clicked()
             addMyRadioStation(name, address);
     }
 }
+
 void Radio::on_editMyRadioStationButton_clicked()
 {
     if (QListWidgetItem *item = ui->myRadioListWidget->currentItem())
@@ -300,10 +301,12 @@ void Radio::on_editMyRadioStationButton_clicked()
         }
     }
 }
+
 void Radio::on_removeMyRadioStationButton_clicked()
 {
     delete ui->myRadioListWidget->currentItem();
 }
+
 void Radio::on_loadMyRadioStationButton_clicked()
 {
     const QString filePath = QFileDialog::getOpenFileName(this, tr("Load radio station list"), QString(), g_fileDialogFilter);
@@ -312,6 +315,7 @@ void Radio::on_loadMyRadioStationButton_clicked()
         loadMyRadios(QSettings(filePath, QSettings::IniFormat).value("Radia").toStringList());
     }
 }
+
 void Radio::on_saveMyRadioStationButton_clicked()
 {
     QString filePath = QFileDialog::getSaveFileName(this, tr("Save radio station list"), QString(), g_fileDialogFilter);
@@ -327,6 +331,7 @@ void Radio::on_myRadioListWidget_itemDoubleClicked(QListWidgetItem *item)
 {
     firstTabItemDoubleClicked(item);
 }
+
 void Radio::on_qmplay2RadioListWidget_itemDoubleClicked(QListWidgetItem *item)
 {
     firstTabItemDoubleClicked(item);
@@ -370,14 +375,17 @@ void Radio::on_searchByComboBox_activated(int idx)
         ui->searchComboBox->setInsertPolicy(QComboBox::InsertAtBottom);
     }
 }
+
 void Radio::on_addRadioBrowserStationButton_clicked()
 {
     QDesktopServices::openUrl(QUrl("http://www.radio-browser.info/gui/#/add"));
 }
+
 void Radio::on_radioView_doubleClicked(const QModelIndex &index)
 {
     radioBrowserPlayOrEnqueue(index, "open");
 }
+
 void Radio::on_radioView_customContextMenuRequested(const QPoint &pos)
 {
     if (ui->radioView->currentIndex().isValid())
@@ -390,6 +398,7 @@ void Radio::radioBrowserPlay()
     if (index.isValid())
         radioBrowserPlayOrEnqueue(index, "open");
 }
+
 void Radio::radioBrowserAdd()
 {
     const QModelIndex index = ui->radioView->currentIndex();
@@ -400,18 +409,21 @@ void Radio::radioBrowserAdd()
         addMyRadioStation(title, url);
     }
 }
+
 void Radio::radioBrowserEnqueue()
 {
     const QModelIndex index = ui->radioView->currentIndex();
     if (index.isValid())
         radioBrowserPlayOrEnqueue(index, "enqueue");
 }
+
 void Radio::radioBrowserOpenHomePage()
 {
     const QModelIndex index = ui->radioView->currentIndex();
     if (index.isValid())
         QDesktopServices::openUrl(m_radioBrowserModel->getHomePageUrl(index));
 }
+
 void Radio::radioBrowserEdit()
 {
     const QModelIndex index = ui->radioView->currentIndex();
@@ -495,6 +507,7 @@ QStringList Radio::getMyRadios() const
         myRadios += item->text() + '\n' + item->data(Qt::UserRole).toString();
     return myRadios;
 }
+
 void Radio::loadMyRadios(const QStringList &radios)
 {
     ui->myRadioListWidget->clear();
@@ -539,3 +552,8 @@ bool Radio::eventFilter(QObject *watched, QEvent *event)
     }
     return QTabWidget::eventFilter(watched, event);
 }
+
+void Radio::triggerTabChanged()
+{
+    tabChanged(currentIndex());
+}
diff --git a/src/modules/Extensions/Radio.hpp b/src/modules/Extensions/Radio.hpp
index 1bf167a5..a5e95949 100644
--- a/src/modules/Extensions/Radio.hpp
+++ b/src/modules/Extensions/Radio.hpp
@@ -24,6 +24,7 @@
 #include <QPointer>
 #include <QIcon>
 #include <QMap>
+#include <QModelIndex>
 
 namespace Ui {
     class Radio;
@@ -36,21 +37,23 @@ class NetworkReply;
 class QTimer;
 class QMenu;
 
-class Radio final : public QTabWidget, public QMPlay2Extensions
+class Radio : public QTabWidget, public QMPlay2Extensions
 {
     Q_OBJECT
 
 public:
     Radio(Module &);
-    ~Radio();
+    ~Radio() final;
 
-    DockWidget *getDockWidget() override;
+    DockWidget *getDockWidget() override final;
 
 private slots:
     void visibilityChanged(const bool v);
 
     void tabChanged(int index);
 
+    void triggerTabChanged();
+
     void qmplay2RadioStationsFinished();
 
     void searchData();
@@ -95,7 +98,7 @@ private:
     void loadMyRadios(const QStringList &radios);
 
 private:
-    bool eventFilter(QObject *watched, QEvent *event) override;
+    bool eventFilter(QObject *watched, QEvent *event) override final;
 
 private:
     const QString m_newStationTxt;
diff --git a/src/modules/Extensions/Radio/RadioBrowserModel.cpp b/src/modules/Extensions/Radio/RadioBrowserModel.cpp
index 395ed835..22641a2e 100644
--- a/src/modules/Extensions/Radio/RadioBrowserModel.cpp
+++ b/src/modules/Extensions/Radio/RadioBrowserModel.cpp
@@ -22,13 +22,14 @@
 #include <Functions.hpp>
 #include <CppUtils.hpp>
 
-#include <QJsonDocument>
-#include <QJsonObject>
-#include <QJsonArray>
 #include <QPainter>
 #include <QWidget>
 #include <QUrl>
 
+#include <QJsonArray.h>
+#include <QJsonDocument.h>
+#include <QJsonObject.h>
+
 #include <algorithm>
 
 struct Column
@@ -394,10 +395,9 @@ void RadioBrowserModel::replyFinished(NetworkReply *reply)
                         if (!image.isNull())
                         {
                             const int s = elementHeight();
-                            const qreal dpr = m_widget->devicePixelRatioF();
+                            const qreal dpr = 1.0;
 
                             column->icon = QPixmap(s * dpr, s * dpr);
-                            column->icon.setDevicePixelRatio(dpr);
                             column->icon.fill(Qt::transparent);
 
                             QPainter painter(&column->icon);
diff --git a/src/modules/Extensions/Radio/RadioBrowserModel.hpp b/src/modules/Extensions/Radio/RadioBrowserModel.hpp
index 9ecd5270..42586e28 100644
--- a/src/modules/Extensions/Radio/RadioBrowserModel.hpp
+++ b/src/modules/Extensions/Radio/RadioBrowserModel.hpp
@@ -30,7 +30,7 @@ class NetworkAccess;
 class NetworkReply;
 struct Column;
 
-class RadioBrowserModel final : public QAbstractItemModel
+class RadioBrowserModel : public QAbstractItemModel
 {
     Q_OBJECT
 
@@ -49,14 +49,14 @@ public:
     QUrl getEditUrl(const QModelIndex &index) const;
     QUrl getHomePageUrl(const QModelIndex &index) const;
 
-    QModelIndex index(int row, int column, const QModelIndex &parent) const override;
-    QModelIndex parent(const QModelIndex &child) const override;
-    int rowCount(const QModelIndex &parent) const override;
-    int columnCount(const QModelIndex &parent) const override;
-    QVariant data(const QModelIndex &index, int role) const override;
-    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override;
-    Qt::ItemFlags flags(const QModelIndex &index) const override;
-    void sort(int columnIdx, Qt::SortOrder order = Qt::AscendingOrder) override;
+    QModelIndex index(int row, int column, const QModelIndex &parent) const override final;
+    QModelIndex parent(const QModelIndex &child) const override final;
+    int rowCount(const QModelIndex &parent) const override final;
+    int columnCount(const QModelIndex &parent) const override final;
+    QVariant data(const QModelIndex &index, int role) const override final;
+    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const override final;
+    Qt::ItemFlags flags(const QModelIndex &index) const override final;
+    void sort(int columnIdx, Qt::SortOrder order = Qt::AscendingOrder) override final;
 
 public slots:
     void setFiltrText(const QString &text = QString());
